﻿using System;

namespace BajoGabor_Amoba
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("AMŐBA");
            Console.WriteLine();
            Console.WriteLine("Két játékos felváltva rak egy 3*3-as táblán. Az első játékos jele: X. A második játékos jele: O.");
            Console.WriteLine("Az győz, akinek sikerül három egyforma jelet rakni egy sorba, oszlopba vagy átlósan!");
            Console.WriteLine("A táblán 1-től 9-ig terjedő számok jelölik az üres mezőket. Lépni az üres mezők számának megadásával lehet.");
            Console.WriteLine();
            Console.WriteLine("Mi az első játékos neve?");
            string elsonev = Console.ReadLine();
            Console.WriteLine("Mi a második játékos neve?");
            string masodiknev = Console.ReadLine();
                        
            char[] tabla = { '1', '2', '3', '4', '5', '6', '7', '8', '9' };            
            Kiir(tabla);
            int lepes = 0; /*hányadik lépésnél tart a játék, maximum 9 lehet*/
            char jel; /*melyik jelet használjuk az adott lépésnél*/
            int jatekos; /*hányadik játékos lép éppen*/
            string nev; /*az aktuális játékos neve*/
            int allas=0; /*játék állása, 0=döntetlen, 1=első játékos nyert, 2=második játékos nyert*/
            do
            {
                lepes++;
                if (lepes%2==0)
                {
                    jel = 'O';
                    nev = masodiknev;
                    jatekos = 2;

                }
                else
                {
                    jel = 'X';
                    nev = elsonev;
                    jatekos = 1;
                }
                int aktualislepes=Lepes(nev, jel, tabla);  
                tabla[aktualislepes - 1] = jel;
                Kiir(tabla);
                if (lepes>4)
                {
                    allas=Ellenorzes(tabla, jatekos);                    
                }
            } while (lepes<9&&allas==0);
            Console.WriteLine("Vége a játéknak!");
            if (allas==0)
            {
                Console.WriteLine("Döntetlen!");
            }
            else
            {
                Console.WriteLine(nev + " nyert! Gratulálok!");
            }
            
            Console.ReadKey();
        }

        private static int Ellenorzes(char[] tabla, int jatekos)
        {
            int allas;
            if (tabla[0] == tabla[1] && tabla[1] == tabla[2]) { allas = jatekos; } /*vízszintes ellenőrzés*/
            else if (tabla[3] == tabla[4] && tabla[4] == tabla[5]) { allas = jatekos; }
            else if (tabla[6] == tabla[7] && tabla[7] == tabla[8]) { allas = jatekos; }
            else if (tabla[0] == tabla[3] && tabla[3] == tabla[6]) { allas = jatekos; } /*függőleges ellenőrzés*/
            else if (tabla[1] == tabla[4] && tabla[4] == tabla[7]) { allas = jatekos; }
            else if (tabla[2] == tabla[5] && tabla[5] == tabla[8]) { allas = jatekos; }
            else if (tabla[0] == tabla[4] && tabla[4] == tabla[8]) { allas = jatekos; } /*átlós ellenőrzés*/
            else if (tabla[2] == tabla[4] && tabla[4] == tabla[6]) { allas = jatekos; }
            else { allas = 0; }
            return allas;
        }

        private static int Lepes(string nev, char jel, char[] tabla)
        {
            bool hiba = true;
            int aktualislepes = 0;
            do
            {
                try
                {
                    Console.WriteLine(nev + " következik, hová szeretnél lépni? Jeled: " + jel);
                    aktualislepes = int.Parse(Console.ReadLine());
                    hiba = false;
                    if (aktualislepes < 1) throw new Exception("0-nál nagyobbat adj meg!");
                    if (aktualislepes > 9) throw new Exception("10-nél kisebbet adj meg!");
                    if (tabla[aktualislepes - 1]=='X'|| tabla[aktualislepes - 1] == 'O') throw new Exception("Ide nem léphetsz, itt már van jel!");
                }
                catch (FormatException)
                {
                    Console.WriteLine("ez nem szám!");
                }
                catch (Exception kivetel)
                {
                    Console.WriteLine(kivetel);
                    hiba = true;
                    Console.WriteLine();
                }
            }
            while (hiba);
            return aktualislepes;

        }

        private static void Kiir(char[] tabla)
        {
            Console.Clear();
            Console.WriteLine("A tábla aktuális állása:");
            Console.WriteLine("———————");
            for (int i = 0; i < 3; i++)
            {
                for (int j = 1; j < 8; j++)
                {
                    if (j%2==0)
                    {
                        Console.Write(tabla[(i * 3) + ((j-1)/2)]);
                    }
                    else
                    {
                        Console.Write("|");
                    }                    
                }
                Console.WriteLine();
                Console.WriteLine("———————");
            }
        }
    }
}
